# NAME

WWW::SwaggerClient::Role - a Moose role for the 1Gb API

 API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  

# VERSION

Automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 2.0.0
- Package version: 1.0.0
- Build date: 2016-11-03T11:50:51.750+04:00
- Build package: class io.swagger.codegen.languages.PerlClientCodegen

## A note on Moose

This role is the only component of the library that uses Moose. See 
WWW::SwaggerClient::ApiFactory for non-Moosey usage. 

# SYNOPSIS

The Perl Swagger Codegen project builds a library of Perl modules to interact with 
a web service defined by a OpenAPI Specification. See below for how to build the 
library.

This module provides an interface to the generated library. All the classes, 
objects, and methods (well, not quite \*all\*, see below) are flattened into this 
role. 

        package MyApp;
        use Moose;
        with 'WWW::SwaggerClient::Role';
        
        package main;
        
        my $api = MyApp->new({ tokens => $tokens });
        
        my $pet = $api->get_pet_by_id(pet_id => $pet_id);
        

## Structure of the library

The library consists of a set of API classes, one for each endpoint. These APIs
implement the method calls available on each endpoint. 

Additionally, there is a set of "object" classes, which represent the objects 
returned by and sent to the methods on the endpoints. 

An API factory class is provided, which builds instances of each endpoint API. 

This Moose role flattens all the methods from the endpoint APIs onto the consuming 
class. It also provides methods to retrieve the endpoint API objects, and the API 
factory object, should you need it. 

For documentation of all these methods, see AUTOMATIC DOCUMENTATION below.

## Configuring authentication

In the normal case, the OpenAPI Spec will describe what parameters are
required and where to put them. You just need to supply the tokens.

    my $tokens = {
        # basic
        username => $username,
        password => $password,
        
        # oauth
        access_token => $oauth_token,
        
        # keys
        $some_key => { token => $token,
                       prefix => $prefix, 
                       in => $in,             # 'head||query',     
                       },
                       
        $another => { token => $token,
                      prefix => $prefix, 
                      in => $in,              # 'head||query',      
                      },                   
        ...,
        
        };
        
        my $api = MyApp->new({ tokens => $tokens });

Note these are all optional, as are `prefix` and `in`, and depend on the API
you are accessing. Usually `prefix` and `in` will be determined by the code generator from
the spec and you will not need to set them at run time. If not, `in` will
default to 'head' and `prefix` to the empty string. 

The tokens will be placed in the `WWW::SwaggerClient::Configuration` namespace
as follows, but you don't need to know about this. 

- `$WWW::SwaggerClient::Configuration::username`

    String. The username for basic auth.

- `$WWW::SwaggerClient::Configuration::password`

    String. The password for basic auth.

- `$WWW::SwaggerClient::Configuration::api_key`

    Hashref. Keyed on the name of each key (there can be multiple tokens).

            $WWW::SwaggerClient::Configuration::api_key = {
                    secretKey => 'aaaabbbbccccdddd',
                    anotherKey => '1111222233334444',
                    };

- `$WWW::SwaggerClient::Configuration::api_key_prefix`

    Hashref. Keyed on the name of each key (there can be multiple tokens). Note not
    all api keys require a prefix.

            $WWW::SwaggerClient::Configuration::api_key_prefix = {
                    secretKey => 'string',
                    anotherKey => 'same or some other string',
                    };

- `$WWW::SwaggerClient::Configuration::access_token`

    String. The OAuth access token. 

# METHODS

## `base_url`

The generated code has the `base_url` already set as a default value. This method 
returns (and optionally sets, but only if the API client has not been 
created yet) the current value of `base_url`.

## `api_factory`

Returns an API factory object. You probably won't need to call this directly. 

        $self->api_factory('Pet'); # returns a WWW::SwaggerClient::PetApi instance
        
        $self->pet_api;            # the same

# MISSING METHODS

Most of the methods on the API are delegated to individual endpoint API objects
(e.g. Pet API, Store API, User API etc). Where different endpoint APIs use the
same method name (e.g. `new()`), these methods can't be delegated. So you need
to call `$api->pet_api->new()`.

In principle, every API is susceptible to the presence of a few, random, undelegatable 
method names. In practice, because of the way method names are constructed, it's 
unlikely in general that any methods will be undelegatable, except for: 

        new()
        class_documentation()
        method_documentation()

To call these methods, you need to get a handle on the relevant object, either
by calling `$api->foo_api` or by retrieving an object, e.g.
`$api->get_pet_by_id(pet_id => $pet_id)`. They are class methods, so
you could also call them on class names.

# BUILDING YOUR LIBRARY

See the homepage `https://github.com/swagger-api/swagger-codegen` for full details. 
But briefly, clone the git repository, build the codegen codebase, set up your build 
config file, then run the API build script. You will need git, Java 7 or 8 and Apache
maven 3.0.3 or better already installed.

The config file should specify the project name for the generated library: 

        {"moduleName":"WWW::MyProjectName"}

Your library files will be built under `WWW::MyProjectName`.

          $ git clone https://github.com/swagger-api/swagger-codegen.git
          $ cd swagger-codegen
          $ mvn package
          $ java -jar modules/swagger-codegen-cli/target/swagger-codegen-cli.jar generate \
    -i [URL or file path to JSON swagger API spec] \
    -l perl \
    -c /path/to/config/file.json \
    -o /path/to/output/folder

Bang, all done. Run the `autodoc` script in the `bin` directory to see the API 
you just built. 

# AUTOMATIC DOCUMENTATION

You can print out a summary of the generated API by running the included
`autodoc` script in the `bin` directory of your generated library. A few
output formats are supported:

          Usage: autodoc [OPTION]

    -w           wide format (default)
    -n           narrow format
    -p           POD format 
    -H           HTML format 
    -m           Markdown format
    -h           print this help message
    -c           your application class
    

The `-c` option allows you to load and inspect your own application. A dummy
namespace is used if you don't supply your own class.

# DOCUMENTATION FROM THE OpenAPI Spec

Additional documentation for each class and method may be provided by the Swagger 
spec. If so, this is available via the `class_documentation()` and 
`method_documentation()` methods on each generated object class, and the 
`method_documentation()` method on the endpoint API classes: 

        my $cmdoc = $api->pet_api->method_documentation->{$method_name}; 
        
        my $odoc = $api->get_pet_by_id->(pet_id => $pet_id)->class_documentation;                                  
        my $omdoc = $api->get_pet_by_id->(pet_id => $pet_id)->method_documentation->{method_name}; 
        

Each of these calls returns a hashref with various useful pieces of information.

# LOAD THE MODULES

To load the API packages:
```perl
use WWW::SwaggerClient::DefaultApi;
use WWW::SwaggerClient::AuthAPIApi;
use WWW::SwaggerClient::DNSApi;
use WWW::SwaggerClient::HostingftpAPIApi;
use WWW::SwaggerClient::HostingiisAPIApi;
use WWW::SwaggerClient::MicrosoftSQLServerApi;
use WWW::SwaggerClient::MySQLPostgresApi;
use WWW::SwaggerClient::VDSHyperVOpenVZApi;

```

To load the models:
```perl
use WWW::SwaggerClient::Object::InlineResponse200;
use WWW::SwaggerClient::Object::InlineResponse2001;
use WWW::SwaggerClient::Object::InlineResponse20010;
use WWW::SwaggerClient::Object::InlineResponse20011;
use WWW::SwaggerClient::Object::InlineResponse20012;
use WWW::SwaggerClient::Object::InlineResponse20013;
use WWW::SwaggerClient::Object::InlineResponse20014;
use WWW::SwaggerClient::Object::InlineResponse2002;
use WWW::SwaggerClient::Object::InlineResponse2003;
use WWW::SwaggerClient::Object::InlineResponse2004;
use WWW::SwaggerClient::Object::InlineResponse2005;
use WWW::SwaggerClient::Object::InlineResponse2006;
use WWW::SwaggerClient::Object::InlineResponse2007;
use WWW::SwaggerClient::Object::InlineResponse2008;
use WWW::SwaggerClient::Object::InlineResponse2009;
use WWW::SwaggerClient::Object::_;

````

# GETTING STARTED
Put the Perl SDK under the 'lib' folder in your project directory, then run the following
```perl
#!/usr/bin/perl
use lib 'lib';
use strict;
use warnings;
# load the API package
use WWW::SwaggerClient::DefaultApi;
use WWW::SwaggerClient::AuthAPIApi;
use WWW::SwaggerClient::DNSApi;
use WWW::SwaggerClient::HostingftpAPIApi;
use WWW::SwaggerClient::HostingiisAPIApi;
use WWW::SwaggerClient::MicrosoftSQLServerApi;
use WWW::SwaggerClient::MySQLPostgresApi;
use WWW::SwaggerClient::VDSHyperVOpenVZApi;

# load the models
use WWW::SwaggerClient::Object::InlineResponse200;
use WWW::SwaggerClient::Object::InlineResponse2001;
use WWW::SwaggerClient::Object::InlineResponse20010;
use WWW::SwaggerClient::Object::InlineResponse20011;
use WWW::SwaggerClient::Object::InlineResponse20012;
use WWW::SwaggerClient::Object::InlineResponse20013;
use WWW::SwaggerClient::Object::InlineResponse20014;
use WWW::SwaggerClient::Object::InlineResponse2002;
use WWW::SwaggerClient::Object::InlineResponse2003;
use WWW::SwaggerClient::Object::InlineResponse2004;
use WWW::SwaggerClient::Object::InlineResponse2005;
use WWW::SwaggerClient::Object::InlineResponse2006;
use WWW::SwaggerClient::Object::InlineResponse2007;
use WWW::SwaggerClient::Object::InlineResponse2008;
use WWW::SwaggerClient::Object::InlineResponse2009;
use WWW::SwaggerClient::Object::_;

# for displaying the API response data
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::DefaultApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации

eval {
    my $result = $api_instance->balance_get(_token_ => $_token_);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling DefaultApi->balance_get: $@\n";
}

```

# DOCUMENTATION FOR API ENDPOINTS

All URIs are relative to *https://www.1gb.ru/api*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**balance_get**](docs/DefaultApi.md#balance_get) | **GET** /balance | Аккаунт: баланс
*DefaultApi* | [**balance_lic_get**](docs/DefaultApi.md#balance_lic_get) | **GET** /balance.lic | Аккаунт: баланс аккаунта лицензий
*DefaultApi* | [**billing_debt_get**](docs/DefaultApi.md#billing_debt_get) | **GET** /billing/debt | Информация по дебету аккаунта
*DefaultApi* | [**billing_info_get**](docs/DefaultApi.md#billing_info_get) | **GET** /billing/info | Информация об аккаунте
*DefaultApi* | [**billing_limits_get**](docs/DefaultApi.md#billing_limits_get) | **GET** /billing/limits | Получить ограничения аккаунта
*DefaultApi* | [**dns_prolong_list_get**](docs/DefaultApi.md#dns_prolong_list_get) | **GET** /dns/prolong/list | Информация по продлению доменов
*DefaultApi* | [**email_add_get**](docs/DefaultApi.md#email_add_get) | **GET** /email/add | Создание почтового ящика
*DefaultApi* | [**email_alias_delete_get**](docs/DefaultApi.md#email_alias_delete_get) | **GET** /email/alias/delete | Удаление псевдонимов почтовых ящиков
*DefaultApi* | [**email_alias_list_get**](docs/DefaultApi.md#email_alias_list_get) | **GET** /email/alias/list | Получить список псевдонимов почтовых ящиков
*DefaultApi* | [**email_delete_get**](docs/DefaultApi.md#email_delete_get) | **GET** /email/delete | Удаление почтового ящика
*DefaultApi* | [**email_list_get**](docs/DefaultApi.md#email_list_get) | **GET** /email/list | Получить список почтовых ящиков
*DefaultApi* | [**updates_last_get**](docs/DefaultApi.md#updates_last_get) | **GET** /updates/last | Идентификатор последнего уведомления в аудите
*DefaultApi* | [**updates_list_get**](docs/DefaultApi.md#updates_list_get) | **GET** /updates/list | Список записей аудита
*DefaultApi* | [**website_delete_get**](docs/DefaultApi.md#website_delete_get) | **GET** /website/delete | Удаление сайта
*DefaultApi* | [**website_list_get**](docs/DefaultApi.md#website_list_get) | **GET** /website/list | Список сайтов аккаунта
*AuthAPIApi* | [**auth_login_post**](docs/AuthAPIApi.md#auth_login_post) | **POST** /auth/login | Получить ключ доступа
*AuthAPIApi* | [**auth_start_get**](docs/AuthAPIApi.md#auth_start_get) | **GET** /auth/start | Получить соль
*DNSApi* | [**dns_add_get**](docs/DNSApi.md#dns_add_get) | **GET** /dns/add | Создание записи домена
*DNSApi* | [**dns_bind_get**](docs/DNSApi.md#dns_bind_get) | **GET** /dns/bind | Привязка одного домена к другому
*DNSApi* | [**dns_list_get**](docs/DNSApi.md#dns_list_get) | **GET** /dns/list | Получить список доменных имён
*DNSApi* | [**dns_prolong_list_get**](docs/DNSApi.md#dns_prolong_list_get) | **GET** /dns/prolong/list | Информация по продлению доменов
*DNSApi* | [**dns_raw_get**](docs/DNSApi.md#dns_raw_get) | **GET** /dns/raw | Редактирование \&quot;сырой\&quot; зоны
*DNSApi* | [**dns_raw_managedmx_get**](docs/DNSApi.md#dns_raw_managedmx_get) | **GET** /dns/raw/managedmx | Редактировать DNS-зону
*HostingftpAPIApi* | [**ftp_list_get**](docs/HostingftpAPIApi.md#ftp_list_get) | **GET** /ftp/list | Получить список зарегистрированных аккаунтов FTP
*HostingiisAPIApi* | [**iis_list_get**](docs/HostingiisAPIApi.md#iis_list_get) | **GET** /iis/list | Список сайтов IIS
*MicrosoftSQLServerApi* | [**mssql_list_get**](docs/MicrosoftSQLServerApi.md#mssql_list_get) | **GET** /mssql/list | Получить список аккаунтов в MSSQL
*MySQLPostgresApi* | [**database_list_get**](docs/MySQLPostgresApi.md#database_list_get) | **GET** /database/list | Список аккаунтов в базах данных UNIX
*VDSHyperVOpenVZApi* | [**vds_create_get**](docs/VDSHyperVOpenVZApi.md#vds_create_get) | **GET** /vds/create | Изменение параметров VDS
*VDSHyperVOpenVZApi* | [**vds_delete_get**](docs/VDSHyperVOpenVZApi.md#vds_delete_get) | **GET** /vds/delete | Удаление VDS
*VDSHyperVOpenVZApi* | [**vds_ip_add_get**](docs/VDSHyperVOpenVZApi.md#vds_ip_add_get) | **GET** /vds/ip/add | Добавление IP на VDS
*VDSHyperVOpenVZApi* | [**vds_ip_delete_get**](docs/VDSHyperVOpenVZApi.md#vds_ip_delete_get) | **GET** /vds/ip/delete | Удаление IP с VDS
*VDSHyperVOpenVZApi* | [**vds_ip_list_get**](docs/VDSHyperVOpenVZApi.md#vds_ip_list_get) | **GET** /vds/ip/list | Список IP-адресов виртуальных серверов
*VDSHyperVOpenVZApi* | [**vds_list_get**](docs/VDSHyperVOpenVZApi.md#vds_list_get) | **GET** /vds/list | Список виртуальных серверов
*VDSHyperVOpenVZApi* | [**vds_reboot_get**](docs/VDSHyperVOpenVZApi.md#vds_reboot_get) | **GET** /vds/reboot | Перезагрузка VDS
*VDSHyperVOpenVZApi* | [**vds_templates_list_get**](docs/VDSHyperVOpenVZApi.md#vds_templates_list_get) | **GET** /vds/templates-list | Список шаблонов виртуальных серверов
*VDSHyperVOpenVZApi* | [**vds_update_get**](docs/VDSHyperVOpenVZApi.md#vds_update_get) | **GET** /vds/update | Создание VDS


# DOCUMENTATION FOR MODELS
 - [WWW::SwaggerClient::Object::InlineResponse200](docs/InlineResponse200.md)
 - [WWW::SwaggerClient::Object::InlineResponse2001](docs/InlineResponse2001.md)
 - [WWW::SwaggerClient::Object::InlineResponse20010](docs/InlineResponse20010.md)
 - [WWW::SwaggerClient::Object::InlineResponse20011](docs/InlineResponse20011.md)
 - [WWW::SwaggerClient::Object::InlineResponse20012](docs/InlineResponse20012.md)
 - [WWW::SwaggerClient::Object::InlineResponse20013](docs/InlineResponse20013.md)
 - [WWW::SwaggerClient::Object::InlineResponse20014](docs/InlineResponse20014.md)
 - [WWW::SwaggerClient::Object::InlineResponse2002](docs/InlineResponse2002.md)
 - [WWW::SwaggerClient::Object::InlineResponse2003](docs/InlineResponse2003.md)
 - [WWW::SwaggerClient::Object::InlineResponse2004](docs/InlineResponse2004.md)
 - [WWW::SwaggerClient::Object::InlineResponse2005](docs/InlineResponse2005.md)
 - [WWW::SwaggerClient::Object::InlineResponse2006](docs/InlineResponse2006.md)
 - [WWW::SwaggerClient::Object::InlineResponse2007](docs/InlineResponse2007.md)
 - [WWW::SwaggerClient::Object::InlineResponse2008](docs/InlineResponse2008.md)
 - [WWW::SwaggerClient::Object::InlineResponse2009](docs/InlineResponse2009.md)
 - [WWW::SwaggerClient::Object::_](docs/_.md)


# DOCUMENTATION FOR AUTHORIATION
 All endpoints do not require authorization.



