# WWW::SwaggerClient::DefaultApi

## Load the API package
```perl
use WWW::SwaggerClient::Object::DefaultApi;
```

All URIs are relative to *https://www.1gb.ru/api*

Method | HTTP request | Description
------------- | ------------- | -------------
[**balance_get**](DefaultApi.md#balance_get) | **GET** /balance | Аккаунт: баланс
[**balance_lic_get**](DefaultApi.md#balance_lic_get) | **GET** /balance.lic | Аккаунт: баланс аккаунта лицензий
[**billing_debt_get**](DefaultApi.md#billing_debt_get) | **GET** /billing/debt | Информация по дебету аккаунта
[**billing_info_get**](DefaultApi.md#billing_info_get) | **GET** /billing/info | Информация об аккаунте
[**billing_limits_get**](DefaultApi.md#billing_limits_get) | **GET** /billing/limits | Получить ограничения аккаунта
[**dns_prolong_list_get**](DefaultApi.md#dns_prolong_list_get) | **GET** /dns/prolong/list | Информация по продлению доменов
[**email_add_get**](DefaultApi.md#email_add_get) | **GET** /email/add | Создание почтового ящика
[**email_alias_delete_get**](DefaultApi.md#email_alias_delete_get) | **GET** /email/alias/delete | Удаление псевдонимов почтовых ящиков
[**email_alias_list_get**](DefaultApi.md#email_alias_list_get) | **GET** /email/alias/list | Получить список псевдонимов почтовых ящиков
[**email_delete_get**](DefaultApi.md#email_delete_get) | **GET** /email/delete | Удаление почтового ящика
[**email_list_get**](DefaultApi.md#email_list_get) | **GET** /email/list | Получить список почтовых ящиков
[**updates_last_get**](DefaultApi.md#updates_last_get) | **GET** /updates/last | Идентификатор последнего уведомления в аудите
[**updates_list_get**](DefaultApi.md#updates_list_get) | **GET** /updates/list | Список записей аудита
[**website_delete_get**](DefaultApi.md#website_delete_get) | **GET** /website/delete | Удаление сайта
[**website_list_get**](DefaultApi.md#website_list_get) | **GET** /website/list | Список сайтов аккаунта


# **balance_get**
> Number balance_get(_token_ => $_token_)

Аккаунт: баланс

Возвращает текущий баланс аккаунта

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::DefaultApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации

eval { 
    my $result = $api_instance->balance_get(_token_ => $_token_);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling DefaultApi->balance_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**Number**](Number.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **balance_lic_get**
> Number balance_lic_get(_token_ => $_token_)

Аккаунт: баланс аккаунта лицензий

Возвращает текущий баланс аккаунта лицензий

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::DefaultApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации

eval { 
    my $result = $api_instance->balance_lic_get(_token_ => $_token_);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling DefaultApi->balance_lic_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**Number**](Number.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **billing_debt_get**
> ARRAY[InlineResponse200] billing_debt_get(_token_ => $_token_)

Информация по дебету аккаунта

Данный запрос позволяет получить информацию по планируемым датам наступления негативного баланса и отключения

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::DefaultApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации

eval { 
    my $result = $api_instance->billing_debt_get(_token_ => $_token_);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling DefaultApi->billing_debt_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**ARRAY[InlineResponse200]**](InlineResponse200.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **billing_info_get**
> ARRAY[InlineResponse2001] billing_info_get(_token_ => $_token_)

Информация об аккаунте

Этот запрос позволяет получить информацию об аккаунте, а также базовую статистику использования ресурсов.

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::DefaultApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации

eval { 
    my $result = $api_instance->billing_info_get(_token_ => $_token_);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling DefaultApi->billing_info_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**ARRAY[InlineResponse2001]**](InlineResponse2001.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **billing_limits_get**
> _ billing_limits_get(_token_ => $_token_)

Получить ограничения аккаунта

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::DefaultApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации

eval { 
    my $result = $api_instance->billing_limits_get(_token_ => $_token_);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling DefaultApi->billing_limits_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**_**](_.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **dns_prolong_list_get**
> ARRAY[InlineResponse2004] dns_prolong_list_get(_token_ => $_token_)

Информация по продлению доменов

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::DefaultApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации

eval { 
    my $result = $api_instance->dns_prolong_list_get(_token_ => $_token_);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling DefaultApi->dns_prolong_list_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**ARRAY[InlineResponse2004]**](InlineResponse2004.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **email_add_get**
> string email_add_get(_token_ => $_token_, add_email => $add_email)

Создание почтового ящика

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::DefaultApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации
my $add_email = 'add_email_example'; # string | Адрес почтового ящика, который необходимо создать

eval { 
    my $result = $api_instance->email_add_get(_token_ => $_token_, add_email => $add_email);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling DefaultApi->email_add_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 
 **add_email** | **string**| Адрес почтового ящика, который необходимо создать | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **email_alias_delete_get**
> string email_alias_delete_get(_token_ => $_token_, _key_ => $_key_)

Удаление псевдонимов почтовых ящиков

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::DefaultApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации
my $_key_ = '_key__example'; # string | Адрес почтового ящика, подлежащего удалению

eval { 
    my $result = $api_instance->email_alias_delete_get(_token_ => $_token_, _key_ => $_key_);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling DefaultApi->email_alias_delete_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 
 **_key_** | **string**| Адрес почтового ящика, подлежащего удалению | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **email_alias_list_get**
> ARRAY[InlineResponse2005] email_alias_list_get(_token_ => $_token_)

Получить список псевдонимов почтовых ящиков

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::DefaultApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации

eval { 
    my $result = $api_instance->email_alias_list_get(_token_ => $_token_);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling DefaultApi->email_alias_list_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**ARRAY[InlineResponse2005]**](InlineResponse2005.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **email_delete_get**
> string email_delete_get(_token_ => $_token_, _key_ => $_key_)

Удаление почтового ящика

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::DefaultApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации
my $_key_ = '_key__example'; # string | Адрес почтового ящика, подлежащего удалению

eval { 
    my $result = $api_instance->email_delete_get(_token_ => $_token_, _key_ => $_key_);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling DefaultApi->email_delete_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 
 **_key_** | **string**| Адрес почтового ящика, подлежащего удалению | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **email_list_get**
> ARRAY[InlineResponse2006] email_list_get(_token_ => $_token_)

Получить список почтовых ящиков

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::DefaultApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации

eval { 
    my $result = $api_instance->email_list_get(_token_ => $_token_);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling DefaultApi->email_list_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**ARRAY[InlineResponse2006]**](InlineResponse2006.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **updates_last_get**
> int updates_last_get(_token_ => $_token_)

Идентификатор последнего уведомления в аудите

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::DefaultApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации

eval { 
    my $result = $api_instance->updates_last_get(_token_ => $_token_);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling DefaultApi->updates_last_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

**int**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **updates_list_get**
> ARRAY[InlineResponse20010] updates_list_get(_token_ => $_token_, _key_ => $_key_)

Список записей аудита

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::DefaultApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации
my $_key_ = 56; # int | ID первой записи для показа или 0 для показа всех записей

eval { 
    my $result = $api_instance->updates_list_get(_token_ => $_token_, _key_ => $_key_);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling DefaultApi->updates_list_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 
 **_key_** | **int**| ID первой записи для показа или 0 для показа всех записей | 

### Return type

[**ARRAY[InlineResponse20010]**](InlineResponse20010.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **website_delete_get**
> string website_delete_get(_token_ => $_token_, _key_ => $_key_)

Удаление сайта

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::DefaultApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации
my $_key_ = '_key__example'; # string | ID сайта, полученный из /website/list

eval { 
    my $result = $api_instance->website_delete_get(_token_ => $_token_, _key_ => $_key_);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling DefaultApi->website_delete_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 
 **_key_** | **string**| ID сайта, полученный из /website/list | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **website_list_get**
> ARRAY[InlineResponse20014] website_list_get(_token_ => $_token_)

Список сайтов аккаунта

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::DefaultApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации

eval { 
    my $result = $api_instance->website_list_get(_token_ => $_token_);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling DefaultApi->website_list_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**ARRAY[InlineResponse20014]**](InlineResponse20014.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

