# WWW::SwaggerClient::AuthAPIApi

## Load the API package
```perl
use WWW::SwaggerClient::Object::AuthAPIApi;
```

All URIs are relative to *https://www.1gb.ru/api*

Method | HTTP request | Description
------------- | ------------- | -------------
[**auth_login_post**](AuthAPIApi.md#auth_login_post) | **POST** /auth/login | Получить ключ доступа
[**auth_start_get**](AuthAPIApi.md#auth_start_get) | **GET** /auth/start | Получить соль


# **auth_login_post**
> string auth_login_post(login => $login, salt => $salt, response => $response)

Получить ключ доступа

Возвращает ключ доступа, с которым в дальнейшем будут осуществляться всё взаимодействие с API  (параметр 'token'). Для вычисления значения параметра 'response' необходимо получить представленную в hex MD5-сумму от  объединения строк пароля пользователя, полученной соли и символа переноса строки. Псевдокод операции:  hex(md5(password&nbsp;+&nbsp;salt&nbsp;+&nbsp;'\\n'))

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::AuthAPIApi->new();
my $login = 'login_example'; # string | Имя пользователя
my $salt = 'salt_example'; # string | Соль (см. /auth/start)
my $response = 'response_example'; # string | Вычисленный хэш

eval { 
    my $result = $api_instance->auth_login_post(login => $login, salt => $salt, response => $response);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling AuthAPIApi->auth_login_post: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **login** | **string**| Имя пользователя | 
 **salt** | **string**| Соль (см. /auth/start) | 
 **response** | **string**| Вычисленный хэш | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **auth_start_get**
> string auth_start_get(login => $login)

Получить соль

Возвращает соль для авторизации. Это первый этап идентификации пользователя. Затем соль используется  во втором, окончательном этапе авторизации, в запросе /auth/login. Запрос не требует дополнительных параметров.

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::AuthAPIApi->new();
my $login = 'login_example'; # string | Имя пользователя

eval { 
    my $result = $api_instance->auth_start_get(login => $login);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling AuthAPIApi->auth_start_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **login** | **string**| Имя пользователя | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

