# WWW::SwaggerClient::DNSApi

## Load the API package
```perl
use WWW::SwaggerClient::Object::DNSApi;
```

All URIs are relative to *https://www.1gb.ru/api*

Method | HTTP request | Description
------------- | ------------- | -------------
[**dns_add_get**](DNSApi.md#dns_add_get) | **GET** /dns/add | Создание записи домена
[**dns_bind_get**](DNSApi.md#dns_bind_get) | **GET** /dns/bind | Привязка одного домена к другому
[**dns_list_get**](DNSApi.md#dns_list_get) | **GET** /dns/list | Получить список доменных имён
[**dns_prolong_list_get**](DNSApi.md#dns_prolong_list_get) | **GET** /dns/prolong/list | Информация по продлению доменов
[**dns_raw_get**](DNSApi.md#dns_raw_get) | **GET** /dns/raw | Редактирование \&quot;сырой\&quot; зоны
[**dns_raw_managedmx_get**](DNSApi.md#dns_raw_managedmx_get) | **GET** /dns/raw/managedmx | Редактировать DNS-зону


# **dns_add_get**
> string dns_add_get(_token_ => $_token_, add_dns_zone => $add_dns_zone, add_dns_record => $add_dns_record, iis_site_for_dns => $iis_site_for_dns, bind_only => $bind_only)

Создание записи домена

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::DNSApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации
my $add_dns_zone = 'add_dns_zone_example'; # string | зона, которую необходимо создать
my $add_dns_record = 'add_dns_record_example'; # string | 
my $iis_site_for_dns = 'iis_site_for_dns_example'; # string | ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку
my $bind_only = 1; # boolean | 

eval { 
    my $result = $api_instance->dns_add_get(_token_ => $_token_, add_dns_zone => $add_dns_zone, add_dns_record => $add_dns_record, iis_site_for_dns => $iis_site_for_dns, bind_only => $bind_only);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling DNSApi->dns_add_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 
 **add_dns_zone** | **string**| зона, которую необходимо создать | 
 **add_dns_record** | **string**|  | [optional] 
 **iis_site_for_dns** | **string**| ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку | [optional] 
 **bind_only** | **boolean**|  | [optional] 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **dns_bind_get**
> string dns_bind_get(_token_ => $_token_, _key_ => $_key_, bind_to => $bind_to)

Привязка одного домена к другому

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::DNSApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации
my $_key_ = 56; # int | ID домена из списка /dns/list
my $bind_to = 'bind_to_example'; # string | домен, к которому необходимо сделать привязку

eval { 
    my $result = $api_instance->dns_bind_get(_token_ => $_token_, _key_ => $_key_, bind_to => $bind_to);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling DNSApi->dns_bind_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 
 **_key_** | **int**| ID домена из списка /dns/list | 
 **bind_to** | **string**| домен, к которому необходимо сделать привязку | [optional] 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **dns_list_get**
> ARRAY[InlineResponse2003] dns_list_get(_token_ => $_token_)

Получить список доменных имён

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::DNSApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации

eval { 
    my $result = $api_instance->dns_list_get(_token_ => $_token_);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling DNSApi->dns_list_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**ARRAY[InlineResponse2003]**](InlineResponse2003.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **dns_prolong_list_get**
> ARRAY[InlineResponse2004] dns_prolong_list_get(_token_ => $_token_)

Информация по продлению доменов

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::DNSApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации

eval { 
    my $result = $api_instance->dns_prolong_list_get(_token_ => $_token_);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling DNSApi->dns_prolong_list_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**ARRAY[InlineResponse2004]**](InlineResponse2004.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **dns_raw_get**
> string dns_raw_get(_token_ => $_token_, _key_ => $_key_, s_del => $s_del, s_add => $s_add, dns_type => $dns_type, dns_name => $dns_name, dns_value => $dns_value)

Редактирование \"сырой\" зоны

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::DNSApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации
my $_key_ = 56; # int | ID домена из /dns/list
my $s_del = 56; # int | Значение '1' сообщает, что запись необходимо удалить
my $s_add = 56; # int | Значение '1' сообщает, что запись необходимо создать
my $dns_type = 'dns_type_example'; # string | Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV
my $dns_name = 'dns_name_example'; # string | Имя записи, либо '@' для корневой
my $dns_value = 'dns_value_example'; # string | Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение)

eval { 
    my $result = $api_instance->dns_raw_get(_token_ => $_token_, _key_ => $_key_, s_del => $s_del, s_add => $s_add, dns_type => $dns_type, dns_name => $dns_name, dns_value => $dns_value);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling DNSApi->dns_raw_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 
 **_key_** | **int**| ID домена из /dns/list | 
 **s_del** | **int**| Значение &#39;1&#39; сообщает, что запись необходимо удалить | 
 **s_add** | **int**| Значение &#39;1&#39; сообщает, что запись необходимо создать | 
 **dns_type** | **string**| Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV | 
 **dns_name** | **string**| Имя записи, либо &#39;@&#39; для корневой | 
 **dns_value** | **string**| Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение) | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **dns_raw_managedmx_get**
> string dns_raw_managedmx_get(_token_ => $_token_, _key_ => $_key_, managed_mx => $managed_mx, upd_managed_mx => $upd_managed_mx)

Редактировать DNS-зону

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::DNSApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации
my $_key_ = 56; # int | ID домена из /dns/list
my $managed_mx = 56; # int | Значение '1', если необходимо включить поддержку на MX-серверах хостинга и '0', если выключить
my $upd_managed_mx = 56; # int | Значение '1' подтверждает операцию

eval { 
    my $result = $api_instance->dns_raw_managedmx_get(_token_ => $_token_, _key_ => $_key_, managed_mx => $managed_mx, upd_managed_mx => $upd_managed_mx);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling DNSApi->dns_raw_managedmx_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 
 **_key_** | **int**| ID домена из /dns/list | 
 **managed_mx** | **int**| Значение &#39;1&#39;, если необходимо включить поддержку на MX-серверах хостинга и &#39;0&#39;, если выключить | 
 **upd_managed_mx** | **int**| Значение &#39;1&#39; подтверждает операцию | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

