# WWW::SwaggerClient::MySQLPostgresApi

## Load the API package
```perl
use WWW::SwaggerClient::Object::MySQLPostgresApi;
```

All URIs are relative to *https://www.1gb.ru/api*

Method | HTTP request | Description
------------- | ------------- | -------------
[**database_list_get**](MySQLPostgresApi.md#database_list_get) | **GET** /database/list | Список аккаунтов в базах данных UNIX


# **database_list_get**
> ARRAY[InlineResponse2002] database_list_get(_token_ => $_token_)

Список аккаунтов в базах данных UNIX

Возвращает список зарегистрированных аккаунтов в базах данных MySQL и Postgres. Для вычисления имени домена необходимо объединить имя базы данных,   идентификатор сервера и суффикс (поле url_suffix). Например, если ID сервера равен 123 (значит это MySQL — см. описание поля 'server' в ответе), а суффикс равен '1gb.ru', то домен   для доступа будет равен 'mysql123.1gb.ru'.

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::MySQLPostgresApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации

eval { 
    my $result = $api_instance->database_list_get(_token_ => $_token_);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling MySQLPostgresApi->database_list_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**ARRAY[InlineResponse2002]**](InlineResponse2002.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

