# WWW::SwaggerClient::VDSHyperVOpenVZApi

## Load the API package
```perl
use WWW::SwaggerClient::Object::VDSHyperVOpenVZApi;
```

All URIs are relative to *https://www.1gb.ru/api*

Method | HTTP request | Description
------------- | ------------- | -------------
[**vds_create_get**](VDSHyperVOpenVZApi.md#vds_create_get) | **GET** /vds/create | Изменение параметров VDS
[**vds_delete_get**](VDSHyperVOpenVZApi.md#vds_delete_get) | **GET** /vds/delete | Удаление VDS
[**vds_ip_add_get**](VDSHyperVOpenVZApi.md#vds_ip_add_get) | **GET** /vds/ip/add | Добавление IP на VDS
[**vds_ip_delete_get**](VDSHyperVOpenVZApi.md#vds_ip_delete_get) | **GET** /vds/ip/delete | Удаление IP с VDS
[**vds_ip_list_get**](VDSHyperVOpenVZApi.md#vds_ip_list_get) | **GET** /vds/ip/list | Список IP-адресов виртуальных серверов
[**vds_list_get**](VDSHyperVOpenVZApi.md#vds_list_get) | **GET** /vds/list | Список виртуальных серверов
[**vds_reboot_get**](VDSHyperVOpenVZApi.md#vds_reboot_get) | **GET** /vds/reboot | Перезагрузка VDS
[**vds_templates_list_get**](VDSHyperVOpenVZApi.md#vds_templates_list_get) | **GET** /vds/templates-list | Список шаблонов виртуальных серверов
[**vds_update_get**](VDSHyperVOpenVZApi.md#vds_update_get) | **GET** /vds/update | Создание VDS


# **vds_create_get**
> string vds_create_get(_token_ => $_token_, type => $type, cr_hvmem => $cr_hvmem, cr_hvdsk => $cr_hvdsk, cr_hvcpu => $cr_hvcpu, template => $template, force_memo => $force_memo, hv_1gb_panel_version => $hv_1gb_panel_version, panel_install => $panel_install, cr_ssd1 => $cr_ssd1, cr_hv_all_system => $cr_hv_all_system)

Изменение параметров VDS

Изменение параметров уже существующего VDS

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::VDSHyperVOpenVZApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации
my $type = 'type_example'; # string | Тип создаваемого VDS. 'vz1', 'vz2', 'vz3', 'vz4', 'vz5' или 'vds.dynamic'. По умолчанию 'vds.dynamic'
my $cr_hvmem = 56; # int | Количество доступной памяти в мегабайтах. По умолчанию 2048
my $cr_hvdsk = 56; # int | Количество доступных гигабайт диска. По умолчанию 30
my $cr_hvcpu = 56; # int | Количество ядер CPU. По умолчанию 2
my $template = 'template_example'; # string | Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list
my $force_memo = 'force_memo_example'; # string | 
my $hv_1gb_panel_version = 'hv_1gb_panel_version_example'; # string | 
my $panel_install = 1; # boolean | Необходимо ли установить панель 1Gb на VDS
my $cr_ssd1 = 1; # boolean | Создать всю систему на SSD
my $cr_hv_all_system = 1; # boolean | Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными)

eval { 
    my $result = $api_instance->vds_create_get(_token_ => $_token_, type => $type, cr_hvmem => $cr_hvmem, cr_hvdsk => $cr_hvdsk, cr_hvcpu => $cr_hvcpu, template => $template, force_memo => $force_memo, hv_1gb_panel_version => $hv_1gb_panel_version, panel_install => $panel_install, cr_ssd1 => $cr_ssd1, cr_hv_all_system => $cr_hv_all_system);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling VDSHyperVOpenVZApi->vds_create_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 
 **type** | **string**| Тип создаваемого VDS. &#39;vz1&#39;, &#39;vz2&#39;, &#39;vz3&#39;, &#39;vz4&#39;, &#39;vz5&#39; или &#39;vds.dynamic&#39;. По умолчанию &#39;vds.dynamic&#39; | [optional] 
 **cr_hvmem** | **int**| Количество доступной памяти в мегабайтах. По умолчанию 2048 | [optional] 
 **cr_hvdsk** | **int**| Количество доступных гигабайт диска. По умолчанию 30 | [optional] 
 **cr_hvcpu** | **int**| Количество ядер CPU. По умолчанию 2 | [optional] 
 **template** | **string**| Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list | [optional] 
 **force_memo** | **string**|  | [optional] 
 **hv_1gb_panel_version** | **string**|  | [optional] 
 **panel_install** | **boolean**| Необходимо ли установить панель 1Gb на VDS | [optional] 
 **cr_ssd1** | **boolean**| Создать всю систему на SSD | [optional] 
 **cr_hv_all_system** | **boolean**| Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными) | [optional] 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **vds_delete_get**
> string vds_delete_get(_token_ => $_token_, _key_ => $_key_, force_critical => $force_critical)

Удаление VDS

Предоставляет функционал для удаления VDS

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::VDSHyperVOpenVZApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации
my $_key_ = 56; # int | ID виртуального сервера, полученный из /vds/list
my $force_critical = 1; # boolean | Если true, VDS будет удален срочно

eval { 
    my $result = $api_instance->vds_delete_get(_token_ => $_token_, _key_ => $_key_, force_critical => $force_critical);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling VDSHyperVOpenVZApi->vds_delete_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 
 **_key_** | **int**| ID виртуального сервера, полученный из /vds/list | 
 **force_critical** | **boolean**| Если true, VDS будет удален срочно | [optional] 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **vds_ip_add_get**
> string vds_ip_add_get(_token_ => $_token_, _key_ => $_key_)

Добавление IP на VDS

Этот вызов позволяет добавить ещё один IP адрес на указанный VDS

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::VDSHyperVOpenVZApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации
my $_key_ = 56; # int | ID виртуального сервера, полученный из /vds/list

eval { 
    my $result = $api_instance->vds_ip_add_get(_token_ => $_token_, _key_ => $_key_);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling VDSHyperVOpenVZApi->vds_ip_add_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 
 **_key_** | **int**| ID виртуального сервера, полученный из /vds/list | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **vds_ip_delete_get**
> string vds_ip_delete_get(_token_ => $_token_, _key_ => $_key_, del_ip => $del_ip)

Удаление IP с VDS

Этот вызов позволяет отвязать IP адрес от VDS

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::VDSHyperVOpenVZApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации
my $_key_ = 56; # int | ID виртуального сервера, полученный из /vds/list
my $del_ip = 'del_ip_example'; # string | IP адрес, который необходимо удалить

eval { 
    my $result = $api_instance->vds_ip_delete_get(_token_ => $_token_, _key_ => $_key_, del_ip => $del_ip);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling VDSHyperVOpenVZApi->vds_ip_delete_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 
 **_key_** | **int**| ID виртуального сервера, полученный из /vds/list | 
 **del_ip** | **string**| IP адрес, который необходимо удалить | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **vds_ip_list_get**
> ARRAY[InlineResponse20011] vds_ip_list_get(_token_ => $_token_, _key_ => $_key_)

Список IP-адресов виртуальных серверов

Список IP-адресов виртуальных серверов

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::VDSHyperVOpenVZApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации
my $_key_ = 56; # int | ID виртуального сервера, полученный из /vds/list

eval { 
    my $result = $api_instance->vds_ip_list_get(_token_ => $_token_, _key_ => $_key_);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling VDSHyperVOpenVZApi->vds_ip_list_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 
 **_key_** | **int**| ID виртуального сервера, полученный из /vds/list | [optional] 

### Return type

[**ARRAY[InlineResponse20011]**](InlineResponse20011.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **vds_list_get**
> ARRAY[InlineResponse20012] vds_list_get(_token_ => $_token_, _key_ => $_key_)

Список виртуальных серверов

Позволяет получить список виртуальных серверов

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::VDSHyperVOpenVZApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации
my $_key_ = 56; # int | ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS

eval { 
    my $result = $api_instance->vds_list_get(_token_ => $_token_, _key_ => $_key_);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling VDSHyperVOpenVZApi->vds_list_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 
 **_key_** | **int**| ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS | [optional] 

### Return type

[**ARRAY[InlineResponse20012]**](InlineResponse20012.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **vds_reboot_get**
> string vds_reboot_get(_token_ => $_token_, _key_ => $_key_)

Перезагрузка VDS

Предоставляет функционал для перезагрузки VDS

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::VDSHyperVOpenVZApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации
my $_key_ = 56; # int | ID виртуального сервера, полученный из /vds/list

eval { 
    my $result = $api_instance->vds_reboot_get(_token_ => $_token_, _key_ => $_key_);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling VDSHyperVOpenVZApi->vds_reboot_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 
 **_key_** | **int**| ID виртуального сервера, полученный из /vds/list | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **vds_templates_list_get**
> ARRAY[InlineResponse20013] vds_templates_list_get(_token_ => $_token_)

Список шаблонов виртуальных серверов

Позволяет получить список шаблонов виртуальных серверов

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::VDSHyperVOpenVZApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации

eval { 
    my $result = $api_instance->vds_templates_list_get(_token_ => $_token_);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling VDSHyperVOpenVZApi->vds_templates_list_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**ARRAY[InlineResponse20013]**](InlineResponse20013.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **vds_update_get**
> string vds_update_get(_token_ => $_token_, _key_ => $_key_, cr_hvmem => $cr_hvmem, cr_hvdsk => $cr_hvdsk, cr_hvcpu => $cr_hvcpu)

Создание VDS

Создание новых VDS с произвольными характеристиками

### Example 
```perl
use Data::Dumper;

my $api_instance = WWW::SwaggerClient::VDSHyperVOpenVZApi->new();
my $_token_ = '_token__example'; # string | Ключ доступа, полученный при авторизации
my $_key_ = 56; # int | ID виртуального сервера, полученный из /vds/list
my $cr_hvmem = 56; # int | Количество доступной памяти в мегабайтах. По умолчанию 2048
my $cr_hvdsk = 56; # int | Количество доступных гигабайт диска. По умолчанию 30
my $cr_hvcpu = 56; # int | Количество ядер CPU. По умолчанию 2

eval { 
    my $result = $api_instance->vds_update_get(_token_ => $_token_, _key_ => $_key_, cr_hvmem => $cr_hvmem, cr_hvdsk => $cr_hvdsk, cr_hvcpu => $cr_hvcpu);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling VDSHyperVOpenVZApi->vds_update_get: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **string**| Ключ доступа, полученный при авторизации | 
 **_key_** | **int**| ID виртуального сервера, полученный из /vds/list | 
 **cr_hvmem** | **int**| Количество доступной памяти в мегабайтах. По умолчанию 2048 | [optional] 
 **cr_hvdsk** | **int**| Количество доступных гигабайт диска. По умолчанию 30 | [optional] 
 **cr_hvcpu** | **int**| Количество ядер CPU. По умолчанию 2 | [optional] 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

