=begin comment

1Gb API

 API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  

OpenAPI spec version: 2.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end comment

=cut

#
# NOTE: This class is auto generated by the swagger code generator program. 
# Do not edit the class manually.
# Ref: https://github.com/swagger-api/swagger-codegen
#
package WWW::SwaggerClient::DefaultApi;

require 5.6.0;
use strict;
use warnings;
use utf8; 
use Exporter;
use Carp qw( croak );
use Log::Any qw($log);

use WWW::SwaggerClient::ApiClient;
use WWW::SwaggerClient::Configuration;

use base "Class::Data::Inheritable";

__PACKAGE__->mk_classdata('method_documentation' => {});

sub new {
    my $class   = shift;
    my (%self) = (
        'api_client' => WWW::SwaggerClient::ApiClient->instance,
        @_
    );

    #my $self = {
    #    #api_client => $options->{api_client}
    #    api_client => $default_api_client
    #}; 

    bless \%self, $class;

}


#
# balance_get
#
# Аккаунт: баланс
# 
# @param string $_token_ Ключ доступа, полученный при авторизации (required)
{
    my $params = {
    '_token_' => {
        data_type => 'string',
        description => 'Ключ доступа, полученный при авторизации',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'balance_get' } = { 
    	summary => 'Аккаунт: баланс',
        params => $params,
        returns => 'Number',
        };
}
# @return Number
#
sub balance_get {
    my ($self, %args) = @_;

    # verify the required parameter '_token_' is set
    unless (exists $args{'_token_'}) {
      croak("Missing the required parameter '_token_' when calling balance_get");
    }

    # parse inputs
    my $_resource_path = '/balance';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/json');

    # query params
    if ( exists $args{'_token_'}) {
        $query_params->{'_token_'} = $self->{api_client}->to_query_value($args{'_token_'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('Number', $response);
    return $_response_object;
}

#
# balance_lic_get
#
# Аккаунт: баланс аккаунта лицензий
# 
# @param string $_token_ Ключ доступа, полученный при авторизации (required)
{
    my $params = {
    '_token_' => {
        data_type => 'string',
        description => 'Ключ доступа, полученный при авторизации',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'balance_lic_get' } = { 
    	summary => 'Аккаунт: баланс аккаунта лицензий',
        params => $params,
        returns => 'Number',
        };
}
# @return Number
#
sub balance_lic_get {
    my ($self, %args) = @_;

    # verify the required parameter '_token_' is set
    unless (exists $args{'_token_'}) {
      croak("Missing the required parameter '_token_' when calling balance_lic_get");
    }

    # parse inputs
    my $_resource_path = '/balance.lic';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/json');

    # query params
    if ( exists $args{'_token_'}) {
        $query_params->{'_token_'} = $self->{api_client}->to_query_value($args{'_token_'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('Number', $response);
    return $_response_object;
}

#
# billing_debt_get
#
# Информация по дебету аккаунта
# 
# @param string $_token_ Ключ доступа, полученный при авторизации (required)
{
    my $params = {
    '_token_' => {
        data_type => 'string',
        description => 'Ключ доступа, полученный при авторизации',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'billing_debt_get' } = { 
    	summary => 'Информация по дебету аккаунта',
        params => $params,
        returns => 'ARRAY[InlineResponse200]',
        };
}
# @return ARRAY[InlineResponse200]
#
sub billing_debt_get {
    my ($self, %args) = @_;

    # verify the required parameter '_token_' is set
    unless (exists $args{'_token_'}) {
      croak("Missing the required parameter '_token_' when calling billing_debt_get");
    }

    # parse inputs
    my $_resource_path = '/billing/debt';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/json');

    # query params
    if ( exists $args{'_token_'}) {
        $query_params->{'_token_'} = $self->{api_client}->to_query_value($args{'_token_'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[InlineResponse200]', $response);
    return $_response_object;
}

#
# billing_info_get
#
# Информация об аккаунте
# 
# @param string $_token_ Ключ доступа, полученный при авторизации (required)
{
    my $params = {
    '_token_' => {
        data_type => 'string',
        description => 'Ключ доступа, полученный при авторизации',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'billing_info_get' } = { 
    	summary => 'Информация об аккаунте',
        params => $params,
        returns => 'ARRAY[InlineResponse2001]',
        };
}
# @return ARRAY[InlineResponse2001]
#
sub billing_info_get {
    my ($self, %args) = @_;

    # verify the required parameter '_token_' is set
    unless (exists $args{'_token_'}) {
      croak("Missing the required parameter '_token_' when calling billing_info_get");
    }

    # parse inputs
    my $_resource_path = '/billing/info';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/json');

    # query params
    if ( exists $args{'_token_'}) {
        $query_params->{'_token_'} = $self->{api_client}->to_query_value($args{'_token_'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[InlineResponse2001]', $response);
    return $_response_object;
}

#
# billing_limits_get
#
# Получить ограничения аккаунта
# 
# @param string $_token_ Ключ доступа, полученный при авторизации (required)
{
    my $params = {
    '_token_' => {
        data_type => 'string',
        description => 'Ключ доступа, полученный при авторизации',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'billing_limits_get' } = { 
    	summary => 'Получить ограничения аккаунта',
        params => $params,
        returns => '_',
        };
}
# @return _
#
sub billing_limits_get {
    my ($self, %args) = @_;

    # verify the required parameter '_token_' is set
    unless (exists $args{'_token_'}) {
      croak("Missing the required parameter '_token_' when calling billing_limits_get");
    }

    # parse inputs
    my $_resource_path = '/billing/limits';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/json');

    # query params
    if ( exists $args{'_token_'}) {
        $query_params->{'_token_'} = $self->{api_client}->to_query_value($args{'_token_'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('_', $response);
    return $_response_object;
}

#
# dns_prolong_list_get
#
# Информация по продлению доменов
# 
# @param string $_token_ Ключ доступа, полученный при авторизации (required)
{
    my $params = {
    '_token_' => {
        data_type => 'string',
        description => 'Ключ доступа, полученный при авторизации',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'dns_prolong_list_get' } = { 
    	summary => 'Информация по продлению доменов',
        params => $params,
        returns => 'ARRAY[InlineResponse2004]',
        };
}
# @return ARRAY[InlineResponse2004]
#
sub dns_prolong_list_get {
    my ($self, %args) = @_;

    # verify the required parameter '_token_' is set
    unless (exists $args{'_token_'}) {
      croak("Missing the required parameter '_token_' when calling dns_prolong_list_get");
    }

    # parse inputs
    my $_resource_path = '/dns/prolong/list';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/json');

    # query params
    if ( exists $args{'_token_'}) {
        $query_params->{'_token_'} = $self->{api_client}->to_query_value($args{'_token_'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[InlineResponse2004]', $response);
    return $_response_object;
}

#
# email_add_get
#
# Создание почтового ящика
# 
# @param string $_token_ Ключ доступа, полученный при авторизации (required)
# @param string $add_email Адрес почтового ящика, который необходимо создать (required)
{
    my $params = {
    '_token_' => {
        data_type => 'string',
        description => 'Ключ доступа, полученный при авторизации',
        required => '1',
    },
    'add_email' => {
        data_type => 'string',
        description => 'Адрес почтового ящика, который необходимо создать',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'email_add_get' } = { 
    	summary => 'Создание почтового ящика',
        params => $params,
        returns => 'string',
        };
}
# @return string
#
sub email_add_get {
    my ($self, %args) = @_;

    # verify the required parameter '_token_' is set
    unless (exists $args{'_token_'}) {
      croak("Missing the required parameter '_token_' when calling email_add_get");
    }

    # verify the required parameter 'add_email' is set
    unless (exists $args{'add_email'}) {
      croak("Missing the required parameter 'add_email' when calling email_add_get");
    }

    # parse inputs
    my $_resource_path = '/email/add';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/json');

    # query params
    if ( exists $args{'_token_'}) {
        $query_params->{'_token_'} = $self->{api_client}->to_query_value($args{'_token_'});
    }

    # query params
    if ( exists $args{'add_email'}) {
        $query_params->{'add_email'} = $self->{api_client}->to_query_value($args{'add_email'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('string', $response);
    return $_response_object;
}

#
# email_alias_delete_get
#
# Удаление псевдонимов почтовых ящиков
# 
# @param string $_token_ Ключ доступа, полученный при авторизации (required)
# @param string $_key_ Адрес почтового ящика, подлежащего удалению (required)
{
    my $params = {
    '_token_' => {
        data_type => 'string',
        description => 'Ключ доступа, полученный при авторизации',
        required => '1',
    },
    '_key_' => {
        data_type => 'string',
        description => 'Адрес почтового ящика, подлежащего удалению',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'email_alias_delete_get' } = { 
    	summary => 'Удаление псевдонимов почтовых ящиков',
        params => $params,
        returns => 'string',
        };
}
# @return string
#
sub email_alias_delete_get {
    my ($self, %args) = @_;

    # verify the required parameter '_token_' is set
    unless (exists $args{'_token_'}) {
      croak("Missing the required parameter '_token_' when calling email_alias_delete_get");
    }

    # verify the required parameter '_key_' is set
    unless (exists $args{'_key_'}) {
      croak("Missing the required parameter '_key_' when calling email_alias_delete_get");
    }

    # parse inputs
    my $_resource_path = '/email/alias/delete';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/json');

    # query params
    if ( exists $args{'_token_'}) {
        $query_params->{'_token_'} = $self->{api_client}->to_query_value($args{'_token_'});
    }

    # query params
    if ( exists $args{'_key_'}) {
        $query_params->{'_key_'} = $self->{api_client}->to_query_value($args{'_key_'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('string', $response);
    return $_response_object;
}

#
# email_alias_list_get
#
# Получить список псевдонимов почтовых ящиков
# 
# @param string $_token_ Ключ доступа, полученный при авторизации (required)
{
    my $params = {
    '_token_' => {
        data_type => 'string',
        description => 'Ключ доступа, полученный при авторизации',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'email_alias_list_get' } = { 
    	summary => 'Получить список псевдонимов почтовых ящиков',
        params => $params,
        returns => 'ARRAY[InlineResponse2005]',
        };
}
# @return ARRAY[InlineResponse2005]
#
sub email_alias_list_get {
    my ($self, %args) = @_;

    # verify the required parameter '_token_' is set
    unless (exists $args{'_token_'}) {
      croak("Missing the required parameter '_token_' when calling email_alias_list_get");
    }

    # parse inputs
    my $_resource_path = '/email/alias/list';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/json');

    # query params
    if ( exists $args{'_token_'}) {
        $query_params->{'_token_'} = $self->{api_client}->to_query_value($args{'_token_'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[InlineResponse2005]', $response);
    return $_response_object;
}

#
# email_delete_get
#
# Удаление почтового ящика
# 
# @param string $_token_ Ключ доступа, полученный при авторизации (required)
# @param string $_key_ Адрес почтового ящика, подлежащего удалению (required)
{
    my $params = {
    '_token_' => {
        data_type => 'string',
        description => 'Ключ доступа, полученный при авторизации',
        required => '1',
    },
    '_key_' => {
        data_type => 'string',
        description => 'Адрес почтового ящика, подлежащего удалению',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'email_delete_get' } = { 
    	summary => 'Удаление почтового ящика',
        params => $params,
        returns => 'string',
        };
}
# @return string
#
sub email_delete_get {
    my ($self, %args) = @_;

    # verify the required parameter '_token_' is set
    unless (exists $args{'_token_'}) {
      croak("Missing the required parameter '_token_' when calling email_delete_get");
    }

    # verify the required parameter '_key_' is set
    unless (exists $args{'_key_'}) {
      croak("Missing the required parameter '_key_' when calling email_delete_get");
    }

    # parse inputs
    my $_resource_path = '/email/delete';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/json');

    # query params
    if ( exists $args{'_token_'}) {
        $query_params->{'_token_'} = $self->{api_client}->to_query_value($args{'_token_'});
    }

    # query params
    if ( exists $args{'_key_'}) {
        $query_params->{'_key_'} = $self->{api_client}->to_query_value($args{'_key_'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('string', $response);
    return $_response_object;
}

#
# email_list_get
#
# Получить список почтовых ящиков
# 
# @param string $_token_ Ключ доступа, полученный при авторизации (required)
{
    my $params = {
    '_token_' => {
        data_type => 'string',
        description => 'Ключ доступа, полученный при авторизации',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'email_list_get' } = { 
    	summary => 'Получить список почтовых ящиков',
        params => $params,
        returns => 'ARRAY[InlineResponse2006]',
        };
}
# @return ARRAY[InlineResponse2006]
#
sub email_list_get {
    my ($self, %args) = @_;

    # verify the required parameter '_token_' is set
    unless (exists $args{'_token_'}) {
      croak("Missing the required parameter '_token_' when calling email_list_get");
    }

    # parse inputs
    my $_resource_path = '/email/list';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/json');

    # query params
    if ( exists $args{'_token_'}) {
        $query_params->{'_token_'} = $self->{api_client}->to_query_value($args{'_token_'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[InlineResponse2006]', $response);
    return $_response_object;
}

#
# updates_last_get
#
# Идентификатор последнего уведомления в аудите
# 
# @param string $_token_ Ключ доступа, полученный при авторизации (required)
{
    my $params = {
    '_token_' => {
        data_type => 'string',
        description => 'Ключ доступа, полученный при авторизации',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'updates_last_get' } = { 
    	summary => 'Идентификатор последнего уведомления в аудите',
        params => $params,
        returns => 'int',
        };
}
# @return int
#
sub updates_last_get {
    my ($self, %args) = @_;

    # verify the required parameter '_token_' is set
    unless (exists $args{'_token_'}) {
      croak("Missing the required parameter '_token_' when calling updates_last_get");
    }

    # parse inputs
    my $_resource_path = '/updates/last';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/json');

    # query params
    if ( exists $args{'_token_'}) {
        $query_params->{'_token_'} = $self->{api_client}->to_query_value($args{'_token_'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('int', $response);
    return $_response_object;
}

#
# updates_list_get
#
# Список записей аудита
# 
# @param string $_token_ Ключ доступа, полученный при авторизации (required)
# @param int $_key_ ID первой записи для показа или 0 для показа всех записей (required)
{
    my $params = {
    '_token_' => {
        data_type => 'string',
        description => 'Ключ доступа, полученный при авторизации',
        required => '1',
    },
    '_key_' => {
        data_type => 'int',
        description => 'ID первой записи для показа или 0 для показа всех записей',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'updates_list_get' } = { 
    	summary => 'Список записей аудита',
        params => $params,
        returns => 'ARRAY[InlineResponse20010]',
        };
}
# @return ARRAY[InlineResponse20010]
#
sub updates_list_get {
    my ($self, %args) = @_;

    # verify the required parameter '_token_' is set
    unless (exists $args{'_token_'}) {
      croak("Missing the required parameter '_token_' when calling updates_list_get");
    }

    # verify the required parameter '_key_' is set
    unless (exists $args{'_key_'}) {
      croak("Missing the required parameter '_key_' when calling updates_list_get");
    }

    # parse inputs
    my $_resource_path = '/updates/list';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/json');

    # query params
    if ( exists $args{'_token_'}) {
        $query_params->{'_token_'} = $self->{api_client}->to_query_value($args{'_token_'});
    }

    # query params
    if ( exists $args{'_key_'}) {
        $query_params->{'_key_'} = $self->{api_client}->to_query_value($args{'_key_'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[InlineResponse20010]', $response);
    return $_response_object;
}

#
# website_delete_get
#
# Удаление сайта
# 
# @param string $_token_ Ключ доступа, полученный при авторизации (required)
# @param string $_key_ ID сайта, полученный из /website/list (required)
{
    my $params = {
    '_token_' => {
        data_type => 'string',
        description => 'Ключ доступа, полученный при авторизации',
        required => '1',
    },
    '_key_' => {
        data_type => 'string',
        description => 'ID сайта, полученный из /website/list',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'website_delete_get' } = { 
    	summary => 'Удаление сайта',
        params => $params,
        returns => 'string',
        };
}
# @return string
#
sub website_delete_get {
    my ($self, %args) = @_;

    # verify the required parameter '_token_' is set
    unless (exists $args{'_token_'}) {
      croak("Missing the required parameter '_token_' when calling website_delete_get");
    }

    # verify the required parameter '_key_' is set
    unless (exists $args{'_key_'}) {
      croak("Missing the required parameter '_key_' when calling website_delete_get");
    }

    # parse inputs
    my $_resource_path = '/website/delete';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/json');

    # query params
    if ( exists $args{'_token_'}) {
        $query_params->{'_token_'} = $self->{api_client}->to_query_value($args{'_token_'});
    }

    # query params
    if ( exists $args{'_key_'}) {
        $query_params->{'_key_'} = $self->{api_client}->to_query_value($args{'_key_'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('string', $response);
    return $_response_object;
}

#
# website_list_get
#
# Список сайтов аккаунта
# 
# @param string $_token_ Ключ доступа, полученный при авторизации (required)
{
    my $params = {
    '_token_' => {
        data_type => 'string',
        description => 'Ключ доступа, полученный при авторизации',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'website_list_get' } = { 
    	summary => 'Список сайтов аккаунта',
        params => $params,
        returns => 'ARRAY[InlineResponse20014]',
        };
}
# @return ARRAY[InlineResponse20014]
#
sub website_list_get {
    my ($self, %args) = @_;

    # verify the required parameter '_token_' is set
    unless (exists $args{'_token_'}) {
      croak("Missing the required parameter '_token_' when calling website_list_get");
    }

    # parse inputs
    my $_resource_path = '/website/list';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/json');

    # query params
    if ( exists $args{'_token_'}) {
        $query_params->{'_token_'} = $self->{api_client}->to_query_value($args{'_token_'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[InlineResponse20014]', $response);
    return $_response_object;
}

1;
