=begin comment

1Gb API

 API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  

OpenAPI spec version: 2.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end comment

=cut

#
# NOTE: This class is auto generated by the swagger code generator program. 
# Do not edit the class manually.
# Ref: https://github.com/swagger-api/swagger-codegen
#
package WWW::SwaggerClient::DNSApi;

require 5.6.0;
use strict;
use warnings;
use utf8; 
use Exporter;
use Carp qw( croak );
use Log::Any qw($log);

use WWW::SwaggerClient::ApiClient;
use WWW::SwaggerClient::Configuration;

use base "Class::Data::Inheritable";

__PACKAGE__->mk_classdata('method_documentation' => {});

sub new {
    my $class   = shift;
    my (%self) = (
        'api_client' => WWW::SwaggerClient::ApiClient->instance,
        @_
    );

    #my $self = {
    #    #api_client => $options->{api_client}
    #    api_client => $default_api_client
    #}; 

    bless \%self, $class;

}


#
# dns_add_get
#
# Создание записи домена
# 
# @param string $_token_ Ключ доступа, полученный при авторизации (required)
# @param string $add_dns_zone зона, которую необходимо создать (required)
# @param string $add_dns_record  (optional)
# @param string $iis_site_for_dns ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку (optional)
# @param boolean $bind_only  (optional)
{
    my $params = {
    '_token_' => {
        data_type => 'string',
        description => 'Ключ доступа, полученный при авторизации',
        required => '1',
    },
    'add_dns_zone' => {
        data_type => 'string',
        description => 'зона, которую необходимо создать',
        required => '1',
    },
    'add_dns_record' => {
        data_type => 'string',
        description => '',
        required => '0',
    },
    'iis_site_for_dns' => {
        data_type => 'string',
        description => 'ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку',
        required => '0',
    },
    'bind_only' => {
        data_type => 'boolean',
        description => '',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'dns_add_get' } = { 
    	summary => 'Создание записи домена',
        params => $params,
        returns => 'string',
        };
}
# @return string
#
sub dns_add_get {
    my ($self, %args) = @_;

    # verify the required parameter '_token_' is set
    unless (exists $args{'_token_'}) {
      croak("Missing the required parameter '_token_' when calling dns_add_get");
    }

    # verify the required parameter 'add_dns_zone' is set
    unless (exists $args{'add_dns_zone'}) {
      croak("Missing the required parameter 'add_dns_zone' when calling dns_add_get");
    }

    # parse inputs
    my $_resource_path = '/dns/add';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/json');

    # query params
    if ( exists $args{'_token_'}) {
        $query_params->{'_token_'} = $self->{api_client}->to_query_value($args{'_token_'});
    }

    # query params
    if ( exists $args{'add_dns_zone'}) {
        $query_params->{'add_dns_zone'} = $self->{api_client}->to_query_value($args{'add_dns_zone'});
    }

    # query params
    if ( exists $args{'add_dns_record'}) {
        $query_params->{'add_dns_record'} = $self->{api_client}->to_query_value($args{'add_dns_record'});
    }

    # query params
    if ( exists $args{'iis_site_for_dns'}) {
        $query_params->{'iis_site_for_dns'} = $self->{api_client}->to_query_value($args{'iis_site_for_dns'});
    }

    # query params
    if ( exists $args{'bind_only'}) {
        $query_params->{'bind_only'} = $self->{api_client}->to_query_value($args{'bind_only'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('string', $response);
    return $_response_object;
}

#
# dns_bind_get
#
# Привязка одного домена к другому
# 
# @param string $_token_ Ключ доступа, полученный при авторизации (required)
# @param int $_key_ ID домена из списка /dns/list (required)
# @param string $bind_to домен, к которому необходимо сделать привязку (optional)
{
    my $params = {
    '_token_' => {
        data_type => 'string',
        description => 'Ключ доступа, полученный при авторизации',
        required => '1',
    },
    '_key_' => {
        data_type => 'int',
        description => 'ID домена из списка /dns/list',
        required => '1',
    },
    'bind_to' => {
        data_type => 'string',
        description => 'домен, к которому необходимо сделать привязку',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'dns_bind_get' } = { 
    	summary => 'Привязка одного домена к другому',
        params => $params,
        returns => 'string',
        };
}
# @return string
#
sub dns_bind_get {
    my ($self, %args) = @_;

    # verify the required parameter '_token_' is set
    unless (exists $args{'_token_'}) {
      croak("Missing the required parameter '_token_' when calling dns_bind_get");
    }

    # verify the required parameter '_key_' is set
    unless (exists $args{'_key_'}) {
      croak("Missing the required parameter '_key_' when calling dns_bind_get");
    }

    # parse inputs
    my $_resource_path = '/dns/bind';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/json');

    # query params
    if ( exists $args{'_token_'}) {
        $query_params->{'_token_'} = $self->{api_client}->to_query_value($args{'_token_'});
    }

    # query params
    if ( exists $args{'_key_'}) {
        $query_params->{'_key_'} = $self->{api_client}->to_query_value($args{'_key_'});
    }

    # query params
    if ( exists $args{'bind_to'}) {
        $query_params->{'bind_to'} = $self->{api_client}->to_query_value($args{'bind_to'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('string', $response);
    return $_response_object;
}

#
# dns_list_get
#
# Получить список доменных имён
# 
# @param string $_token_ Ключ доступа, полученный при авторизации (required)
{
    my $params = {
    '_token_' => {
        data_type => 'string',
        description => 'Ключ доступа, полученный при авторизации',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'dns_list_get' } = { 
    	summary => 'Получить список доменных имён',
        params => $params,
        returns => 'ARRAY[InlineResponse2003]',
        };
}
# @return ARRAY[InlineResponse2003]
#
sub dns_list_get {
    my ($self, %args) = @_;

    # verify the required parameter '_token_' is set
    unless (exists $args{'_token_'}) {
      croak("Missing the required parameter '_token_' when calling dns_list_get");
    }

    # parse inputs
    my $_resource_path = '/dns/list';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/json');

    # query params
    if ( exists $args{'_token_'}) {
        $query_params->{'_token_'} = $self->{api_client}->to_query_value($args{'_token_'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[InlineResponse2003]', $response);
    return $_response_object;
}

#
# dns_prolong_list_get
#
# Информация по продлению доменов
# 
# @param string $_token_ Ключ доступа, полученный при авторизации (required)
{
    my $params = {
    '_token_' => {
        data_type => 'string',
        description => 'Ключ доступа, полученный при авторизации',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'dns_prolong_list_get' } = { 
    	summary => 'Информация по продлению доменов',
        params => $params,
        returns => 'ARRAY[InlineResponse2004]',
        };
}
# @return ARRAY[InlineResponse2004]
#
sub dns_prolong_list_get {
    my ($self, %args) = @_;

    # verify the required parameter '_token_' is set
    unless (exists $args{'_token_'}) {
      croak("Missing the required parameter '_token_' when calling dns_prolong_list_get");
    }

    # parse inputs
    my $_resource_path = '/dns/prolong/list';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/json');

    # query params
    if ( exists $args{'_token_'}) {
        $query_params->{'_token_'} = $self->{api_client}->to_query_value($args{'_token_'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[InlineResponse2004]', $response);
    return $_response_object;
}

#
# dns_raw_get
#
# Редактирование \"сырой\" зоны
# 
# @param string $_token_ Ключ доступа, полученный при авторизации (required)
# @param int $_key_ ID домена из /dns/list (required)
# @param int $s_del Значение &#39;1&#39; сообщает, что запись необходимо удалить (required)
# @param int $s_add Значение &#39;1&#39; сообщает, что запись необходимо создать (required)
# @param string $dns_type Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV (required)
# @param string $dns_name Имя записи, либо &#39;@&#39; для корневой (required)
# @param string $dns_value Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение) (required)
{
    my $params = {
    '_token_' => {
        data_type => 'string',
        description => 'Ключ доступа, полученный при авторизации',
        required => '1',
    },
    '_key_' => {
        data_type => 'int',
        description => 'ID домена из /dns/list',
        required => '1',
    },
    's_del' => {
        data_type => 'int',
        description => 'Значение &#39;1&#39; сообщает, что запись необходимо удалить',
        required => '1',
    },
    's_add' => {
        data_type => 'int',
        description => 'Значение &#39;1&#39; сообщает, что запись необходимо создать',
        required => '1',
    },
    'dns_type' => {
        data_type => 'string',
        description => 'Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV',
        required => '1',
    },
    'dns_name' => {
        data_type => 'string',
        description => 'Имя записи, либо &#39;@&#39; для корневой',
        required => '1',
    },
    'dns_value' => {
        data_type => 'string',
        description => 'Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение)',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'dns_raw_get' } = { 
    	summary => 'Редактирование \&quot;сырой\&quot; зоны',
        params => $params,
        returns => 'string',
        };
}
# @return string
#
sub dns_raw_get {
    my ($self, %args) = @_;

    # verify the required parameter '_token_' is set
    unless (exists $args{'_token_'}) {
      croak("Missing the required parameter '_token_' when calling dns_raw_get");
    }

    # verify the required parameter '_key_' is set
    unless (exists $args{'_key_'}) {
      croak("Missing the required parameter '_key_' when calling dns_raw_get");
    }

    # verify the required parameter 's_del' is set
    unless (exists $args{'s_del'}) {
      croak("Missing the required parameter 's_del' when calling dns_raw_get");
    }

    # verify the required parameter 's_add' is set
    unless (exists $args{'s_add'}) {
      croak("Missing the required parameter 's_add' when calling dns_raw_get");
    }

    # verify the required parameter 'dns_type' is set
    unless (exists $args{'dns_type'}) {
      croak("Missing the required parameter 'dns_type' when calling dns_raw_get");
    }

    # verify the required parameter 'dns_name' is set
    unless (exists $args{'dns_name'}) {
      croak("Missing the required parameter 'dns_name' when calling dns_raw_get");
    }

    # verify the required parameter 'dns_value' is set
    unless (exists $args{'dns_value'}) {
      croak("Missing the required parameter 'dns_value' when calling dns_raw_get");
    }

    # parse inputs
    my $_resource_path = '/dns/raw';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/json');

    # query params
    if ( exists $args{'_token_'}) {
        $query_params->{'_token_'} = $self->{api_client}->to_query_value($args{'_token_'});
    }

    # query params
    if ( exists $args{'_key_'}) {
        $query_params->{'_key_'} = $self->{api_client}->to_query_value($args{'_key_'});
    }

    # query params
    if ( exists $args{'s_del'}) {
        $query_params->{'s_del'} = $self->{api_client}->to_query_value($args{'s_del'});
    }

    # query params
    if ( exists $args{'s_add'}) {
        $query_params->{'s_add'} = $self->{api_client}->to_query_value($args{'s_add'});
    }

    # query params
    if ( exists $args{'dns_type'}) {
        $query_params->{'dns_type'} = $self->{api_client}->to_query_value($args{'dns_type'});
    }

    # query params
    if ( exists $args{'dns_name'}) {
        $query_params->{'dns_name'} = $self->{api_client}->to_query_value($args{'dns_name'});
    }

    # query params
    if ( exists $args{'dns_value'}) {
        $query_params->{'dns_value'} = $self->{api_client}->to_query_value($args{'dns_value'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('string', $response);
    return $_response_object;
}

#
# dns_raw_managedmx_get
#
# Редактировать DNS-зону
# 
# @param string $_token_ Ключ доступа, полученный при авторизации (required)
# @param int $_key_ ID домена из /dns/list (required)
# @param int $managed_mx Значение &#39;1&#39;, если необходимо включить поддержку на MX-серверах хостинга и &#39;0&#39;, если выключить (required)
# @param int $upd_managed_mx Значение &#39;1&#39; подтверждает операцию (required)
{
    my $params = {
    '_token_' => {
        data_type => 'string',
        description => 'Ключ доступа, полученный при авторизации',
        required => '1',
    },
    '_key_' => {
        data_type => 'int',
        description => 'ID домена из /dns/list',
        required => '1',
    },
    'managed_mx' => {
        data_type => 'int',
        description => 'Значение &#39;1&#39;, если необходимо включить поддержку на MX-серверах хостинга и &#39;0&#39;, если выключить',
        required => '1',
    },
    'upd_managed_mx' => {
        data_type => 'int',
        description => 'Значение &#39;1&#39; подтверждает операцию',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'dns_raw_managedmx_get' } = { 
    	summary => 'Редактировать DNS-зону',
        params => $params,
        returns => 'string',
        };
}
# @return string
#
sub dns_raw_managedmx_get {
    my ($self, %args) = @_;

    # verify the required parameter '_token_' is set
    unless (exists $args{'_token_'}) {
      croak("Missing the required parameter '_token_' when calling dns_raw_managedmx_get");
    }

    # verify the required parameter '_key_' is set
    unless (exists $args{'_key_'}) {
      croak("Missing the required parameter '_key_' when calling dns_raw_managedmx_get");
    }

    # verify the required parameter 'managed_mx' is set
    unless (exists $args{'managed_mx'}) {
      croak("Missing the required parameter 'managed_mx' when calling dns_raw_managedmx_get");
    }

    # verify the required parameter 'upd_managed_mx' is set
    unless (exists $args{'upd_managed_mx'}) {
      croak("Missing the required parameter 'upd_managed_mx' when calling dns_raw_managedmx_get");
    }

    # parse inputs
    my $_resource_path = '/dns/raw/managedmx';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/json');

    # query params
    if ( exists $args{'_token_'}) {
        $query_params->{'_token_'} = $self->{api_client}->to_query_value($args{'_token_'});
    }

    # query params
    if ( exists $args{'_key_'}) {
        $query_params->{'_key_'} = $self->{api_client}->to_query_value($args{'_key_'});
    }

    # query params
    if ( exists $args{'managed_mx'}) {
        $query_params->{'managed_mx'} = $self->{api_client}->to_query_value($args{'managed_mx'});
    }

    # query params
    if ( exists $args{'upd_managed_mx'}) {
        $query_params->{'upd_managed_mx'} = $self->{api_client}->to_query_value($args{'upd_managed_mx'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('string', $response);
    return $_response_object;
}

1;
