=begin comment

1Gb API

 API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  

OpenAPI spec version: 2.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end comment

=cut

#
# NOTE: This class is auto generated by the swagger code generator program. 
# Do not edit the class manually.
# Ref: https://github.com/swagger-api/swagger-codegen
#
package WWW::SwaggerClient::VDSHyperVOpenVZApi;

require 5.6.0;
use strict;
use warnings;
use utf8; 
use Exporter;
use Carp qw( croak );
use Log::Any qw($log);

use WWW::SwaggerClient::ApiClient;
use WWW::SwaggerClient::Configuration;

use base "Class::Data::Inheritable";

__PACKAGE__->mk_classdata('method_documentation' => {});

sub new {
    my $class   = shift;
    my (%self) = (
        'api_client' => WWW::SwaggerClient::ApiClient->instance,
        @_
    );

    #my $self = {
    #    #api_client => $options->{api_client}
    #    api_client => $default_api_client
    #}; 

    bless \%self, $class;

}


#
# vds_create_get
#
# Изменение параметров VDS
# 
# @param string $_token_ Ключ доступа, полученный при авторизации (required)
# @param string $type Тип создаваемого VDS. &#39;vz1&#39;, &#39;vz2&#39;, &#39;vz3&#39;, &#39;vz4&#39;, &#39;vz5&#39; или &#39;vds.dynamic&#39;. По умолчанию &#39;vds.dynamic&#39; (optional)
# @param int $cr_hvmem Количество доступной памяти в мегабайтах. По умолчанию 2048 (optional)
# @param int $cr_hvdsk Количество доступных гигабайт диска. По умолчанию 30 (optional)
# @param int $cr_hvcpu Количество ядер CPU. По умолчанию 2 (optional)
# @param string $template Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list (optional)
# @param string $force_memo  (optional)
# @param string $hv_1gb_panel_version  (optional)
# @param boolean $panel_install Необходимо ли установить панель 1Gb на VDS (optional)
# @param boolean $cr_ssd1 Создать всю систему на SSD (optional)
# @param boolean $cr_hv_all_system Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными) (optional)
{
    my $params = {
    '_token_' => {
        data_type => 'string',
        description => 'Ключ доступа, полученный при авторизации',
        required => '1',
    },
    'type' => {
        data_type => 'string',
        description => 'Тип создаваемого VDS. &#39;vz1&#39;, &#39;vz2&#39;, &#39;vz3&#39;, &#39;vz4&#39;, &#39;vz5&#39; или &#39;vds.dynamic&#39;. По умолчанию &#39;vds.dynamic&#39;',
        required => '0',
    },
    'cr_hvmem' => {
        data_type => 'int',
        description => 'Количество доступной памяти в мегабайтах. По умолчанию 2048',
        required => '0',
    },
    'cr_hvdsk' => {
        data_type => 'int',
        description => 'Количество доступных гигабайт диска. По умолчанию 30',
        required => '0',
    },
    'cr_hvcpu' => {
        data_type => 'int',
        description => 'Количество ядер CPU. По умолчанию 2',
        required => '0',
    },
    'template' => {
        data_type => 'string',
        description => 'Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list',
        required => '0',
    },
    'force_memo' => {
        data_type => 'string',
        description => '',
        required => '0',
    },
    'hv_1gb_panel_version' => {
        data_type => 'string',
        description => '',
        required => '0',
    },
    'panel_install' => {
        data_type => 'boolean',
        description => 'Необходимо ли установить панель 1Gb на VDS',
        required => '0',
    },
    'cr_ssd1' => {
        data_type => 'boolean',
        description => 'Создать всю систему на SSD',
        required => '0',
    },
    'cr_hv_all_system' => {
        data_type => 'boolean',
        description => 'Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными)',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'vds_create_get' } = { 
    	summary => 'Изменение параметров VDS',
        params => $params,
        returns => 'string',
        };
}
# @return string
#
sub vds_create_get {
    my ($self, %args) = @_;

    # verify the required parameter '_token_' is set
    unless (exists $args{'_token_'}) {
      croak("Missing the required parameter '_token_' when calling vds_create_get");
    }

    # parse inputs
    my $_resource_path = '/vds/create';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/json');

    # query params
    if ( exists $args{'_token_'}) {
        $query_params->{'_token_'} = $self->{api_client}->to_query_value($args{'_token_'});
    }

    # query params
    if ( exists $args{'type'}) {
        $query_params->{'type'} = $self->{api_client}->to_query_value($args{'type'});
    }

    # query params
    if ( exists $args{'cr_hvmem'}) {
        $query_params->{'cr_hvmem'} = $self->{api_client}->to_query_value($args{'cr_hvmem'});
    }

    # query params
    if ( exists $args{'cr_hvdsk'}) {
        $query_params->{'cr_hvdsk'} = $self->{api_client}->to_query_value($args{'cr_hvdsk'});
    }

    # query params
    if ( exists $args{'cr_hvcpu'}) {
        $query_params->{'cr_hvcpu'} = $self->{api_client}->to_query_value($args{'cr_hvcpu'});
    }

    # query params
    if ( exists $args{'template'}) {
        $query_params->{'template'} = $self->{api_client}->to_query_value($args{'template'});
    }

    # query params
    if ( exists $args{'force_memo'}) {
        $query_params->{'force_memo'} = $self->{api_client}->to_query_value($args{'force_memo'});
    }

    # query params
    if ( exists $args{'hv_1gb_panel_version'}) {
        $query_params->{'hv_1gb_panel_version'} = $self->{api_client}->to_query_value($args{'hv_1gb_panel_version'});
    }

    # query params
    if ( exists $args{'panel_install'}) {
        $query_params->{'panel_install'} = $self->{api_client}->to_query_value($args{'panel_install'});
    }

    # query params
    if ( exists $args{'cr_ssd1'}) {
        $query_params->{'cr_ssd1'} = $self->{api_client}->to_query_value($args{'cr_ssd1'});
    }

    # query params
    if ( exists $args{'cr_hv_all_system'}) {
        $query_params->{'cr_hv_all_system'} = $self->{api_client}->to_query_value($args{'cr_hv_all_system'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('string', $response);
    return $_response_object;
}

#
# vds_delete_get
#
# Удаление VDS
# 
# @param string $_token_ Ключ доступа, полученный при авторизации (required)
# @param int $_key_ ID виртуального сервера, полученный из /vds/list (required)
# @param boolean $force_critical Если true, VDS будет удален срочно (optional)
{
    my $params = {
    '_token_' => {
        data_type => 'string',
        description => 'Ключ доступа, полученный при авторизации',
        required => '1',
    },
    '_key_' => {
        data_type => 'int',
        description => 'ID виртуального сервера, полученный из /vds/list',
        required => '1',
    },
    'force_critical' => {
        data_type => 'boolean',
        description => 'Если true, VDS будет удален срочно',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'vds_delete_get' } = { 
    	summary => 'Удаление VDS',
        params => $params,
        returns => 'string',
        };
}
# @return string
#
sub vds_delete_get {
    my ($self, %args) = @_;

    # verify the required parameter '_token_' is set
    unless (exists $args{'_token_'}) {
      croak("Missing the required parameter '_token_' when calling vds_delete_get");
    }

    # verify the required parameter '_key_' is set
    unless (exists $args{'_key_'}) {
      croak("Missing the required parameter '_key_' when calling vds_delete_get");
    }

    # parse inputs
    my $_resource_path = '/vds/delete';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/json');

    # query params
    if ( exists $args{'_token_'}) {
        $query_params->{'_token_'} = $self->{api_client}->to_query_value($args{'_token_'});
    }

    # query params
    if ( exists $args{'_key_'}) {
        $query_params->{'_key_'} = $self->{api_client}->to_query_value($args{'_key_'});
    }

    # query params
    if ( exists $args{'force_critical'}) {
        $query_params->{'force_critical'} = $self->{api_client}->to_query_value($args{'force_critical'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('string', $response);
    return $_response_object;
}

#
# vds_ip_add_get
#
# Добавление IP на VDS
# 
# @param string $_token_ Ключ доступа, полученный при авторизации (required)
# @param int $_key_ ID виртуального сервера, полученный из /vds/list (required)
{
    my $params = {
    '_token_' => {
        data_type => 'string',
        description => 'Ключ доступа, полученный при авторизации',
        required => '1',
    },
    '_key_' => {
        data_type => 'int',
        description => 'ID виртуального сервера, полученный из /vds/list',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'vds_ip_add_get' } = { 
    	summary => 'Добавление IP на VDS',
        params => $params,
        returns => 'string',
        };
}
# @return string
#
sub vds_ip_add_get {
    my ($self, %args) = @_;

    # verify the required parameter '_token_' is set
    unless (exists $args{'_token_'}) {
      croak("Missing the required parameter '_token_' when calling vds_ip_add_get");
    }

    # verify the required parameter '_key_' is set
    unless (exists $args{'_key_'}) {
      croak("Missing the required parameter '_key_' when calling vds_ip_add_get");
    }

    # parse inputs
    my $_resource_path = '/vds/ip/add';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/json');

    # query params
    if ( exists $args{'_token_'}) {
        $query_params->{'_token_'} = $self->{api_client}->to_query_value($args{'_token_'});
    }

    # query params
    if ( exists $args{'_key_'}) {
        $query_params->{'_key_'} = $self->{api_client}->to_query_value($args{'_key_'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('string', $response);
    return $_response_object;
}

#
# vds_ip_delete_get
#
# Удаление IP с VDS
# 
# @param string $_token_ Ключ доступа, полученный при авторизации (required)
# @param int $_key_ ID виртуального сервера, полученный из /vds/list (required)
# @param string $del_ip IP адрес, который необходимо удалить (required)
{
    my $params = {
    '_token_' => {
        data_type => 'string',
        description => 'Ключ доступа, полученный при авторизации',
        required => '1',
    },
    '_key_' => {
        data_type => 'int',
        description => 'ID виртуального сервера, полученный из /vds/list',
        required => '1',
    },
    'del_ip' => {
        data_type => 'string',
        description => 'IP адрес, который необходимо удалить',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'vds_ip_delete_get' } = { 
    	summary => 'Удаление IP с VDS',
        params => $params,
        returns => 'string',
        };
}
# @return string
#
sub vds_ip_delete_get {
    my ($self, %args) = @_;

    # verify the required parameter '_token_' is set
    unless (exists $args{'_token_'}) {
      croak("Missing the required parameter '_token_' when calling vds_ip_delete_get");
    }

    # verify the required parameter '_key_' is set
    unless (exists $args{'_key_'}) {
      croak("Missing the required parameter '_key_' when calling vds_ip_delete_get");
    }

    # verify the required parameter 'del_ip' is set
    unless (exists $args{'del_ip'}) {
      croak("Missing the required parameter 'del_ip' when calling vds_ip_delete_get");
    }

    # parse inputs
    my $_resource_path = '/vds/ip/delete';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/json');

    # query params
    if ( exists $args{'_token_'}) {
        $query_params->{'_token_'} = $self->{api_client}->to_query_value($args{'_token_'});
    }

    # query params
    if ( exists $args{'_key_'}) {
        $query_params->{'_key_'} = $self->{api_client}->to_query_value($args{'_key_'});
    }

    # query params
    if ( exists $args{'del_ip'}) {
        $query_params->{'del_ip'} = $self->{api_client}->to_query_value($args{'del_ip'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('string', $response);
    return $_response_object;
}

#
# vds_ip_list_get
#
# Список IP-адресов виртуальных серверов
# 
# @param string $_token_ Ключ доступа, полученный при авторизации (required)
# @param int $_key_ ID виртуального сервера, полученный из /vds/list (optional)
{
    my $params = {
    '_token_' => {
        data_type => 'string',
        description => 'Ключ доступа, полученный при авторизации',
        required => '1',
    },
    '_key_' => {
        data_type => 'int',
        description => 'ID виртуального сервера, полученный из /vds/list',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'vds_ip_list_get' } = { 
    	summary => 'Список IP-адресов виртуальных серверов',
        params => $params,
        returns => 'ARRAY[InlineResponse20011]',
        };
}
# @return ARRAY[InlineResponse20011]
#
sub vds_ip_list_get {
    my ($self, %args) = @_;

    # verify the required parameter '_token_' is set
    unless (exists $args{'_token_'}) {
      croak("Missing the required parameter '_token_' when calling vds_ip_list_get");
    }

    # parse inputs
    my $_resource_path = '/vds/ip/list';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/json');

    # query params
    if ( exists $args{'_token_'}) {
        $query_params->{'_token_'} = $self->{api_client}->to_query_value($args{'_token_'});
    }

    # query params
    if ( exists $args{'_key_'}) {
        $query_params->{'_key_'} = $self->{api_client}->to_query_value($args{'_key_'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[InlineResponse20011]', $response);
    return $_response_object;
}

#
# vds_list_get
#
# Список виртуальных серверов
# 
# @param string $_token_ Ключ доступа, полученный при авторизации (required)
# @param int $_key_ ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS (optional)
{
    my $params = {
    '_token_' => {
        data_type => 'string',
        description => 'Ключ доступа, полученный при авторизации',
        required => '1',
    },
    '_key_' => {
        data_type => 'int',
        description => 'ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'vds_list_get' } = { 
    	summary => 'Список виртуальных серверов',
        params => $params,
        returns => 'ARRAY[InlineResponse20012]',
        };
}
# @return ARRAY[InlineResponse20012]
#
sub vds_list_get {
    my ($self, %args) = @_;

    # verify the required parameter '_token_' is set
    unless (exists $args{'_token_'}) {
      croak("Missing the required parameter '_token_' when calling vds_list_get");
    }

    # parse inputs
    my $_resource_path = '/vds/list';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/json');

    # query params
    if ( exists $args{'_token_'}) {
        $query_params->{'_token_'} = $self->{api_client}->to_query_value($args{'_token_'});
    }

    # query params
    if ( exists $args{'_key_'}) {
        $query_params->{'_key_'} = $self->{api_client}->to_query_value($args{'_key_'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[InlineResponse20012]', $response);
    return $_response_object;
}

#
# vds_reboot_get
#
# Перезагрузка VDS
# 
# @param string $_token_ Ключ доступа, полученный при авторизации (required)
# @param int $_key_ ID виртуального сервера, полученный из /vds/list (required)
{
    my $params = {
    '_token_' => {
        data_type => 'string',
        description => 'Ключ доступа, полученный при авторизации',
        required => '1',
    },
    '_key_' => {
        data_type => 'int',
        description => 'ID виртуального сервера, полученный из /vds/list',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'vds_reboot_get' } = { 
    	summary => 'Перезагрузка VDS',
        params => $params,
        returns => 'string',
        };
}
# @return string
#
sub vds_reboot_get {
    my ($self, %args) = @_;

    # verify the required parameter '_token_' is set
    unless (exists $args{'_token_'}) {
      croak("Missing the required parameter '_token_' when calling vds_reboot_get");
    }

    # verify the required parameter '_key_' is set
    unless (exists $args{'_key_'}) {
      croak("Missing the required parameter '_key_' when calling vds_reboot_get");
    }

    # parse inputs
    my $_resource_path = '/vds/reboot';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/json');

    # query params
    if ( exists $args{'_token_'}) {
        $query_params->{'_token_'} = $self->{api_client}->to_query_value($args{'_token_'});
    }

    # query params
    if ( exists $args{'_key_'}) {
        $query_params->{'_key_'} = $self->{api_client}->to_query_value($args{'_key_'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('string', $response);
    return $_response_object;
}

#
# vds_templates_list_get
#
# Список шаблонов виртуальных серверов
# 
# @param string $_token_ Ключ доступа, полученный при авторизации (required)
{
    my $params = {
    '_token_' => {
        data_type => 'string',
        description => 'Ключ доступа, полученный при авторизации',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'vds_templates_list_get' } = { 
    	summary => 'Список шаблонов виртуальных серверов',
        params => $params,
        returns => 'ARRAY[InlineResponse20013]',
        };
}
# @return ARRAY[InlineResponse20013]
#
sub vds_templates_list_get {
    my ($self, %args) = @_;

    # verify the required parameter '_token_' is set
    unless (exists $args{'_token_'}) {
      croak("Missing the required parameter '_token_' when calling vds_templates_list_get");
    }

    # parse inputs
    my $_resource_path = '/vds/templates-list';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/json');

    # query params
    if ( exists $args{'_token_'}) {
        $query_params->{'_token_'} = $self->{api_client}->to_query_value($args{'_token_'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[InlineResponse20013]', $response);
    return $_response_object;
}

#
# vds_update_get
#
# Создание VDS
# 
# @param string $_token_ Ключ доступа, полученный при авторизации (required)
# @param int $_key_ ID виртуального сервера, полученный из /vds/list (required)
# @param int $cr_hvmem Количество доступной памяти в мегабайтах. По умолчанию 2048 (optional)
# @param int $cr_hvdsk Количество доступных гигабайт диска. По умолчанию 30 (optional)
# @param int $cr_hvcpu Количество ядер CPU. По умолчанию 2 (optional)
{
    my $params = {
    '_token_' => {
        data_type => 'string',
        description => 'Ключ доступа, полученный при авторизации',
        required => '1',
    },
    '_key_' => {
        data_type => 'int',
        description => 'ID виртуального сервера, полученный из /vds/list',
        required => '1',
    },
    'cr_hvmem' => {
        data_type => 'int',
        description => 'Количество доступной памяти в мегабайтах. По умолчанию 2048',
        required => '0',
    },
    'cr_hvdsk' => {
        data_type => 'int',
        description => 'Количество доступных гигабайт диска. По умолчанию 30',
        required => '0',
    },
    'cr_hvcpu' => {
        data_type => 'int',
        description => 'Количество ядер CPU. По умолчанию 2',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'vds_update_get' } = { 
    	summary => 'Создание VDS',
        params => $params,
        returns => 'string',
        };
}
# @return string
#
sub vds_update_get {
    my ($self, %args) = @_;

    # verify the required parameter '_token_' is set
    unless (exists $args{'_token_'}) {
      croak("Missing the required parameter '_token_' when calling vds_update_get");
    }

    # verify the required parameter '_key_' is set
    unless (exists $args{'_key_'}) {
      croak("Missing the required parameter '_key_' when calling vds_update_get");
    }

    # parse inputs
    my $_resource_path = '/vds/update';
    $_resource_path =~ s/{format}/json/; # default format to json

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/json');

    # query params
    if ( exists $args{'_token_'}) {
        $query_params->{'_token_'} = $self->{api_client}->to_query_value($args{'_token_'});
    }

    # query params
    if ( exists $args{'_key_'}) {
        $query_params->{'_key_'} = $self->{api_client}->to_query_value($args{'_key_'});
    }

    # query params
    if ( exists $args{'cr_hvmem'}) {
        $query_params->{'cr_hvmem'} = $self->{api_client}->to_query_value($args{'cr_hvmem'});
    }

    # query params
    if ( exists $args{'cr_hvdsk'}) {
        $query_params->{'cr_hvdsk'} = $self->{api_client}->to_query_value($args{'cr_hvdsk'});
    }

    # query params
    if ( exists $args{'cr_hvcpu'}) {
        $query_params->{'cr_hvcpu'} = $self->{api_client}->to_query_value($args{'cr_hvcpu'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('string', $response);
    return $_response_object;
}

1;
